#include <kopf.h>
#include <math.h>
#include <malen.h>

int Spalten, Zeilen, ix, iy, n;
double arim, sdm, xmax, xmin, dmax, mediwert, sxw, szw, R;

double werte[10][20], zwert[200], xwert[200];
double dmwerte[200], sortiert[200];

void Grafik (void);
void Getmaxdummy (void);
void TransValtoDummy (void);
void Sortieren(void);
void GetOneVal(void);
void getRanges(void);
void GetStanrdMiddle (void);
void GetValues (void);
void Arimwert(void);
void GetRowsValues(double zwerte[], double xwert[]);
void GetColsValues (void);
void Showvalues (void);
void GetColsRows (void);

void COLOR(int text, int hint)
{
_settextcolor(text);
_setbkcolor(hint);
}

void main(void)
{
int wouhi, zwerte, wertesumme, ry, rx;
anfang: CLS();
   COLOR(4, 7);
   LOCATE (24, 1);
   printf("geschrieben von Josef Wismeth QF1b");

hauptmenue: LOCATE(1, 1);
  iy = 6; ix = 1;
  Zeilen = 1; Spalten = 5;
  n = Spalten * Zeilen;
  COLOR(4, 7);
  printf("Statis - Das Statistik-Programm");
  COLOR(1, 7);
  printf("\nExit=Esc  Spalten&Zeilen=F1 Werte-in=f2 EinzelWert-in=f3 ");
  printf("Grafik=F4 Werte=f5");
  COLOR(1, 0);

eini: wouhi = FTASTE();
      if (wouhi == 1) goto finito;
      if (wouhi == 59) goto werte;
      if (wouhi == 60) goto eingabe;
      if (wouhi == 61) goto einwert;
      if (wouhi == 62) goto zeichnen;
      if (wouhi == 63) goto gezeigt;
   goto eini;

zeichnen: Grafik();
      goto anfang;

gezeigt: Showvalues();
      goto rechnen;

werte: _settextcolor(2);
       GetColsRows();
       COLOR(1, 0);
     goto eini;

einwert: GetOneVal();
     goto rechnen;
    
eingabe: _settextcolor(2);
	/*
        REDIM SHARED werte(Zeilen, Spalten), zwert(Spalten), xwert(Zeilen)
	 REDIM SHARED dmwerte(n), sortiert(n)  */
	 GetValues();

rechnen: if ((Spalten > 1) && (Zeilen > 1))
	  {
	   GetColsValues();
	   GetRowsValues(zwert, xwert);
	  }
if ((Zeilen == 1) ||(Spalten == 1))
  {
      wertesumme = 0;
       for (ry = 1; ry <= Zeilen; ry++)
       {
	for (rx = 1; rx <= Spalten; rx++)
	 wertesumme += werte[ry][rx];
       }
       LOCATE ((Zeilen + iy + 2), 1);
       printf("Summe aller Werte: %f   ", wertesumme);
  }
_settextcolor(14);
Arimwert();
GetStanrdMiddle();
getRanges();
Sortieren();
goto hauptmenue;

finito: COLOR(7, 0);
	CLS();
}
void Arimwert(void)
{
int ry, rx;
      n = Zeilen * Spalten;
      arim = 0;
      for (ry = 1; ry <= Zeilen; ry++)
      {
       for (rx = 1; rx <= Spalten; rx++)
	arim +=  werte[ry][rx];
      }
      arim = arim / n;
      ZEILS((Zeilen + iy + 5));
      LOCATE((Zeilen + iy + 3), 1);
      printf ("Arithmetischer Mittelwert= %f", arim);
}

void GetColsRows(void)
{
 ZEILS(3);
 LOCATE(3, 1); printf("Spalten: "); scanf("%d", &Spalten);
 ZEILS(3);
 LOCATE(3, 1); printf("Zeilen: "); scanf("%d", &Zeilen);
 n = Spalten * Zeilen;
 COLOR(6, 7);
 LOCATE(1, 35);
 printf("Spalten=%d Zeilen=%d Elementenzahl= %d", Spalten, Zeilen, n);
 ZEILS(3);
}

void GetColsValues(void)
{
int ry, rx, a, za;
      for (ry = 1;ry <= Zeilen; ry++)
       {
       xwert[ry] = 0;
	for (rx == 1; rx<= Spalten;rx++)
	  xwert[ry] = xwert[ry] + werte[ry][rx];
	LOCATE ((iy + ry), (Spalten * 3 + 5));
	printf("%f", xwert[ry]);
	if( za >= Zeilen) ix += 3;
       }
      szw = 0;
 for (a = 1; a <= Zeilen; a++)
  sxw += xwert[a];

LOCATE ((Zeilen + iy + 4), 1);
printf("Summe Spaltenwerte: %f", sxw);
}

void Getmaxdummy(void)
{
 int d;
 dmax = 0;
 for (d = 1; d <= n; d++)
  if (dmwerte[d] > dmax) dmax = dmwerte[d];
}

void GetOneVal(void)
{
int col, row;
   ZEILS(4);
   LOCATE (4, 1);
   if (Zeilen > 1)  {printf("Gewuenschte Zeile: "); scanf("%f", &row);  }
   if (Spalten > 1) {printf("Gewuenschte Spalte: "); scanf("%f", &col); }
   if (Zeilen == 1) row = 1;
   if (Spalten == 1)  col = 1;
   ZEILS(5);
   LOCATE(5, 1);
   printf("Neuer Wert fr Variable(Zeile,Spalte): ");
   scanf("%f", &werte[row][col]);
   ZEILS(5);
   Showvalues();
}

void getRanges(void)
{
 int ry, rx;
  xmax = 0;
  for ( ry = 1; ry <= Zeilen; ry++)
  for (rx = 1; rx <= Spalten; ry++)
   if (werte[ry][rx] > xmax)  xmax = werte[ry][rx];
  xmin = xmax;
  for ( ry = 1; ry <= Zeilen; ry++)
  for (rx = 1; rx <= Spalten; ry++)
   if (werte[ry][rx] < xmin) xmin = werte[ry][rx];
  R = xmax - xmin;
  LOCATE( (Zeilen + iy + 5), 1);
  printf("xmax=%f  xmin=%f   Range R=%f", xmax ,xmin, R);
}

void GetRowsValues (double zwerte[], double xwert[])
{
 int a, rx, ry;
 ix = 1;
      for (rx = 1; rx <= Spalten; rx++)
      zwert[rx] = 0;
      for (ry = 1; ry <= Zeilen;ry++)
       {
	 zwert[rx] += werte[ry][rx];
	  LOCATE( (Zeilen + iy + 2), ix);
	    if (ry >= Zeilen) ix += 3;
	  printf("%f", zwert[rx]);
      }

szw = 0;
for (a = 1; a <= Spalten; a++)
szw += zwert[a];

LOCATE((Zeilen + iy + 3), 1);
printf("Summe Zeilenwerte:  %f", szw);
}

void GetStanrdMiddle(void)
{
 int ry, rx;
 double differenz, quadrat, summe, produkt;
      sdm = 0;
      for (ry = 1; ry <= Zeilen; ry++)
      for (rx = 1; rx <= Spalten; rx++)
       {
       differenz = werte[ry][rx] - arim;
       produkt = differenz * differenz;
       summe += produkt;
       }
      quadrat = summe / (n - 1);
      sdm = sqrt(quadrat);
      ZEILS((Zeilen + iy + 6));
      LOCATE ((Zeilen + iy + 4), 1);
      printf("Standardabweichung=%f  Elementenanzahl= %d", sdm, n );
}

void GetValues(void)
{
int z, x;
for (x = 1; x <= Spalten;x++)
  for (z = 1; z <= Zeilen; z++)
   {
    LOCATE(4, 1);
    printf("Zeile: %d Spalte: %d", z, x);
    /* LOCATE(5, 1);
     *PRINT "                "
     *LOCATE 5, 1 */
    scanf("%f", &werte[z][x]);
    ZEILS(4);
    Showvalues();
   }
}

void Grafik(void)
{
int xa, xe, diff, dy, ye, farbe, x, z, intmax, ymax, dummya, dummyb;
SCREEN(9);
CLS();
xa = 60;

LOCATE(2, 30); printf("Messwerte");
LOCATE(3, 1); printf("%f", xmax);
LOCATE(23, 1); printf("%f", xmin);
LINE (55, 320, 600, 320, 3);

farbe = 1;
for (x = 1; x <= Spalten; x++)
  for (z = 1; z <= Zeilen; z++)
  {
  dmax = xmax;
  intmax = (int)(xmax);
  ymax = (int)xmax - intmax;
   dummya = (int)werte[z][x];
   dummyb = (int)(werte[z][x] - (double)dummya);

     diff = dummyb / ymax;
     dy = diff * 290;
     ye = 320 - dy;
     xe = xa + 10;
    Rechteck(xa, 320, xe, ye, farbe);
    farbe++;
    xa += 10;
  }

getch();
SCREEN(3);
}

void Showvalues(void)
{
int za, xa, x, y;
   x = ix; y = iy;
if ((Spalten > 1) && (Zeilen > 1))
 {
   ZEILS((1 + y));
   for (xa = 1 ; xa <= Spalten; xa++)
   for (za = 1; za <= Zeilen;za++)
      LOCATE( (za + y), x );
      if (za >= Zeilen) x += 3;
      printf("%f", werte[za][xa]);
 }

if ((Spalten == 1) || (Zeilen == 1))
 {
  ZEILS(iy);
  LOCATE(iy, ix);
  for (xa = 1; xa <= Spalten; xa++)
    for (za = 1; za <= Zeilen; za++)
     printf("%f", werte[za][xa]);
  }
}

void Sortieren(void)
{
int a, b, c, g;
double aposa, aposb, apos;
TransValtoDummy();

a = n;
dmax = xmax;
 for(b = 1; b <= n; b++)
  {
  for (c = 1; c <= n; c++)
   if (dmwerte[c] == dmax)
   {
    sortiert[a] = dmax;
    dmwerte[c] = -1000000;
    a--;
   }
     Getmaxdummy();
  }

g = n % 2;
if (g > 0)
 {
  apos = (n / 2) + .5;
  mediwert = sortiert[(int)apos];
 }
if (g == 0)
 {
  aposa = n / 2;
  aposb = (n / 2) + 1;
  mediwert = sortiert[(int)aposa];
  mediwert = (mediwert + sortiert[(int)aposb]) / 2;
 }

LOCATE ((Zeilen + iy + 6), 1);
printf( "Meridianwert= %f", mediwert);
}

void TransValtoDummy(void)
{
int y, x, z, a;
a = 1;
for (x = 1; x <= Spalten; x++)
  for( z = 1; z <= Zeilen; z++)
   {
    dmwerte[a] = werte[z][x];
    a++;
   }
}


